package com.emato.cuspay.wx.common;

import com.emato.cuspay.common.contant.TablePrimaryKeyPrefix;
import com.emato.cuspay.common.core.db.IdWorkerAide;
import com.emato.cuspay.entity.merch.MerchNoti;
import com.emato.cuspay.entity.merch.MerchPayCfg;
import com.emato.cuspay.wx.entity.WxCbPayDoc;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * @author zx
 * @version 1.0
 * 2018-05-19 09:02
 */
public class MerchNotiBuilder {

    private SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

    /**
     * 默认通知次数
     */
    private final int defaultCount = 1;

    private MerchNoti merchNoti;

    public MerchNotiBuilder() {
        this.merchNoti = new MerchNoti();
        this.merchNoti.setNotiSn(TablePrimaryKeyPrefix.merch_pay_noti_type + IdWorkerAide.nextId());
        this.merchNoti.setNotiCount(defaultCount);
        this.merchNoti.setIsStoped(WxDict.IsStopStatus.i_0.getItem());
        this.merchNoti.setNotiStatue(WxDict.NoticeStatus.i_0.getItem());
    }

    public MerchNotiBuilder wxCbPay(WxCbPayDoc wxCbPay) {
        this.merchNoti.setMerchErpOrderSn(wxCbPay.getMerchErpOrderSn());
        this.merchNoti.setMerchSn(wxCbPay.getMerchSn());
        this.merchNoti.setMerchName(wxCbPay.getMerchName());
        this.merchNoti.setPlatSn(wxCbPay.getPlatSn());
        this.merchNoti.setPlatName(wxCbPay.getPlatName());
        this.merchNoti.setThirdPartyMerchCode(wxCbPay.getThirdPartyMerchCode());
        this.merchNoti.setThirdPartyMerchName(wxCbPay.getThirdPartyMerchName());
        this.merchNoti.setAllMerchId(wxCbPay.getMchId());
        this.merchNoti.setAllOrderNo(wxCbPay.getOutTradeNo());
        this.merchNoti.setAllPayNo(wxCbPay.getTransactionId());
        this.merchNoti.setAllSubOrderNo(wxCbPay.getSubOrderNo());
        this.merchNoti.setCreaterSn("1");
        this.merchNoti.setCreateTime(sdf.format(new Date()));
        return this;
    }

    public MerchNotiBuilder merchPay(MerchPayCfg merchPay) {
        this.merchNoti.setPayChnlFlag(merchPay.getPayChnlFlag());
        this.merchNoti.setNotifyUrl(merchPay.getNotifyUrl());
        return this;
    }

    public MerchNotiBuilder code(String code) {
        this.merchNoti.setCode(code);
        return this;
    }

    public MerchNotiBuilder msg(String msg) {
        this.merchNoti.setMsg(msg);
        return this;
    }

    public MerchNotiBuilder cusDeclStatus(String cusDeclStatus) {
        this.merchNoti.setCusDeclStatus(cusDeclStatus);
        return this;
    }

    public MerchNotiBuilder notiCount(Integer count) {
        int notiCount = (count != null && count > 0) ? count : defaultCount;
        this.merchNoti.setNotiCount(notiCount);
        return this;
    }

    public MerchNotiBuilder certCheckResult(String result) {
        this.merchNoti.setBuyerPayerCheck(result);
        return  this;
    }

    public MerchNoti build() {
        return this.merchNoti;
    }

}
